
#ifndef _H_MCL_AST
#define _H_MCL_AST

#include "loc.h"
#include "dyn_arr.h"


DEFINE_DA(ast_node, void*);


typedef enum ast_type_e {
    AT_BIN_ADD,
    AT_BIN_SUB,
    AT_BIN_DIV,
    AT_BIN_MUL,
    AT_UN_DEREF,
    AT_UN_XOR,
    AT_FUNC,
    AT_ASSIGN,
    AT_EXPR,
} ast_type_t;

typedef struct ast_ident_s {
    char* name;
    loc_t loc;
} ast_ident_t;

typedef struct type_s {
    ast_ident_t name;
    struct type_s* inner;
} type_t;


typedef struct ast_node_s {
    ast_type_t* type;
    loc_t loc;
} ast_node_t;


typedef struct ast_program_s {
    mcl_da_ast_node_t body;
    loc_t loc;
} ast_program_t;

typedef struct ast_func_param_s {
    ast_ident_t name;
    type_t type;
} ast_func_param_t;

DEFINE_DA(func_param, ast_func_param_t);

typedef struct ast_func_decl_s {
    ast_type_t* type;
    loc_t loc;
    ast_ident_t id;
    mcl_da_func_param_t params;
    mcl_da_ast_node_t body;
} ast_func_decl_t;

#endif