#ifndef _H_MCL_LOG
#define _H_MCL_LOG

#include "loc.h"

#ifdef _LOG_COLORS
    #define RESET  "\x1b[0m"
    #define BRIGHT  "\x1b[1m"
    #define DIM  "\x1b[2m"
    #define UNDERSCORE  "\x1b[4m"
    #define BLINK  "\x1b[5m"
    #define REVERSE  "\x1b[7m"
    #define HIDDEN  "\x1b[8m"
    #define FG_BLACK  "\x1b[30m"
    #define FG_RED  "\x1b[31m"
    #define FG_GREEN  "\x1b[32m"
    #define FG_YELLOW  "\x1b[33m"
    #define FG_BLUE  "\x1b[34m"
    #define FG_MAGENTA  "\x1b[35m"
    #define FG_CYAN  "\x1b[36m"
    #define FG_WHITE  "\x1b[37m"
    #define BG_BLACK  "\x1b[40m"
    #define BG_RED  "\x1b[41m"
    #define BG_GREEN  "\x1b[42m"
    #define BG_YELLOW  "\x1b[43m"
    #define BG_BLUE  "\x1b[44m"
    #define BG_MAGENTA  "\x1b[45m"
    #define BG_CYAN  "\x1b[46m"
    #define BG_WHITE  "\x1b[47m"
#endif


typedef enum log_level_e {
    ERROR = 0,
    WARN,
    HELP,
    INFO,
    DEBUG,
} log_level_t;

static log_level_t FILTER_LEVEL = INFO;

void mcl_log(log_level_t level, const char* fmt, ...);
void mcl_log_loc(log_level_t level, loc_t* loc, const char* fmt, ...);

#endif