#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "cliargs.h"
#include "dyn_arr.h"
#include "token.h"
#include "tokeniser.h"
#include "parser.h"
#include "logger.h"

int main(int argc, char** argv) {
    cliargs_t* cliargs = parse_cliargs(argc, argv); 
    mcl_log(DEBUG, "Output file: %s", cliargs->output);

    MCL_DA_FOR_IN(char*, &cliargs->input, file, {
        mcl_log(DEBUG, "Input file: %s", file);
        tokeniser_t* tokeniser = tokenise(file);
        if (!tokeniser) {
            mcl_log(ERROR, "Failed to tokenise");
            return 1;
        }
        MCL_DA_FOR_IN(token_t, &tokeniser->tokens, token, {
            printf("%s:%zu:%zu: %s\n", 
                    token.loc.file, 
                    token.loc.line, 
                    token.loc.col, 
                    token_to_string(&token));
        });
        //ast_program_t* prog = parse(&tokeniser->tokens);
        
    });
    return 0;
}